



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【行为型】Mediator模式</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【行为型】Mediator模式</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-17 22:21:32 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>中介者模式目的是将对象间的交互封装在一个对象中，从而使用各对象间的相互依赖解耦，并可以独立更改对像间的交互。在实际项目开发过程中，因某些原因（如：业务逻辑处理不当或设计不当等）使得多个不同对象间需要相互(引用)访问，无形当中使得原本几个不相干的或相对较为独立的几个模块产生了相互依赖。随着依赖程度的恶化，后期项目维护将是十分被动的。举个大家可能平时都有遇到过的例子，A界面点击了某个按钮，导致B界面需要关掉。许多人(尤其是新手程序员)总是在A界面的按钮事件响应时调用了B界面的close()行为。接着可能又由于某些需求，B界面的某些行为执行时，会影响到A、C界面等等，明显的，原本这些不相干的界面现在都产生了相互依赖，如此必定会影响后期的维护。此时，一种解决手段就可以使用该中介者模式。先看下没有使用中介者模式与使用中介者模式两种情况的对象交互情况。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/317300/201606/317300-20160614093645729-607026434.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/317300/201606/317300-20160614093654682-1491950077.png" /></p>
<p>由上所述可明显看出该模式的目的意图，下面是中介者模式的类关系图参考结构：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/317300/201606/317300-20160614093807229-2011943520.png" /></p>
<p>模式的编码结构参考如下：</p>
<div>
<div>
<pre class="prettyprint linenums"> namespace mediator<br />
 {<br />
     //<br />
     // 此处只设计简单的中介者对象，如果有必要，Mediator的设计，完全可以考虑使用Observer<br />
     // 模式来设计。使用Observer模式来设计Mediator，则相对会更通用些，当然设计也相对更为<br />
     // 复杂些。如果实际情况较为简单时，则只需要使用简单方式实现Mediator即可(参考如下)。<br />
     // 

     // 各模块对象类型<br />
     class ModuleA {};<br />
     class ModuelB {};<br />
     class ModuelC<br />
     {<br />
     public:<br />
         void doSomething() {}<br />
     };<br />
     class ModuelD<br />
     {<br />
     public:<br />
         void doSomething() {}<br />
     };<br />
     class ModuelE {};

     // 中介者对象类型,此处不再弄个基类.<br />
     class Mediator<br />
     {<br />
     public:<br />
         void actionA() {<br />
             // some code here.such as below.<br />
             m_pModuleC-&gt;doSomething();<br />
             m_pModuleD-&gt;doSomething();<br />
         }<br />
         // some other code here........

     private:<br />
         ModuleA* m_pModuleA;<br />
         ModuelB* m_pModuleB;<br />
         ModuelC* m_pModuleC;<br />
         ModuelD* m_pModuleD;<br />
         ModuelE* m_pModuleE;<br />
     };

 }//namespace mediator</pre>
</div>
<p>Mediator模式编码结构参考</p></div>
<p>Mediator模式重在将几个处于&ldquo;同级别&rdquo;（或称为同层次结构上）的模块对象的依赖解耦。即：如上的各个模块间，它们并不存在明显的上下层次关系，它们是处于同一层次层面的对象。比如两个维护着不同模块的数据的数据维护对象class ClanDataMgr;和class ChatDataMgr;一般情况下，这两个对象间是没有交集的，但由于某些原因，开发者让他们间产生了交集（注意：这只是个举例而已）。之前在介绍结构型模式时，也有一个模式也是解决类似这种依赖性错综复杂的依赖关系问题，该模式是：Facade模式。但Facade模式意图是将应用对子系统的依赖解耦，即：应用与子系统间是存在明显的上下层依赖关系，这也是Facade模式与Mediator模式的不同之处。</p>
<p>在设计Mediator时，如果实际情况较为复杂，还需要考虑日后交互的变动。比如可参考上述类关系参考图中的抽象IMediaotr设计方案，又或者考虑使用Strategy模式方案等等。如果实际情况较为简单，模块对象间的交互又相对较为固定，则使用简单设计Mediator即可。实际如果设计，最终还是视具体项目情况分析而定。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r937ozn8.html">php面向对象学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z663nq.html">Beta版本的贡献率百分比</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e6d3xq.html">db2icrt创建实例，提示主机名无效</a>
		</li>
						<li><a href="https://www.batexi.com/a/390w724q.html">C&num;引用COM对象，报错：《类型 &ast;&ast;&ast; 未定义构造函数&comma; 无法嵌入互操作类型 &ast;&ast;&ast; 。请改用适用的接口》的解决办法。</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyegvm9.html">微信公众账号开发教程（四）自定义菜单（含实例源码）&mdash;&mdash;转自http&colon;&sol;&sol;www&period;cnblogs&period;com&sol;yank&sol;p&sol;3418194&period;html</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvzl7xq.html">Ext&period;form&period;ComboBox  后台取值 动态加载    ext5&period;0&period;0</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y2ox5q.html">git stash的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xl0jm8.html">一次服务器CPU占用率高的定位分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj04ry9.html">【典型错误】The type java&period;lang&period;Object cannot be resolved&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x6d308.html">jquery1&period;11 操作checkbox：全选、取消全选、获取选择元素、获取取消选择元素（总结）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp1rm79.html">svn自动发用户名密码到邮件（明文密码）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mmdl38.html">3D MAX脚本教程1</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdxxjy9.html">Spring&plus;SpringMVC&plus;MyBatis&plus;easyUI整合基础篇（八）mysql中文查询bug修复</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk6l0j8.html">JavaScript实现全选和全不选</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gexoge8.html">css动画-音频跳动</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd4ovd9.html">10分钟详解Spring全家桶7大知识点</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvveyl8.html">Plugin with id &amp;&num;39&semi;com&period;novoda&period;bintray-release&amp;&num;39&semi; not found&period;的解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy20lgq.html">jquery获取select选择的文本与值</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy6vxd9.html">常用模块Part&lpar;2&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93we6g0q.html">hibernate 中，出现了错误 &amp;quot&semi;node to traverse cannot be null&excl;&amp;quot&semi; 如何改正</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qlm3k5x9.html">MFC 显示CImg图片</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydj6k2q.html">英蓓特Mars board的android4&period;0&period;3源码编译过程</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm3pkx9.html">Python开发&mdash;Ajax系列</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydjogjq.html">tomcat环境搭建</a>
			</li>
						<li><a href="https://www.batexi.com/a/96ow4439.html">Unity3D 画线插件 Vectrosity&lowbar;Simple2DLine</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmvxxl9.html">html中em和px</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnmxxd8.html">OpenCV 编码样式指南</a>
			</li>
						<li><a href="https://www.batexi.com/a/93x2lon9.html">2013ACM暑假集训总结-致将走上大三征途的我</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xkv4z8.html">&lbrack;c&num;&rsqb;如何在form的webbrowser控件中获得鼠标坐标</a>
			</li>
						<li><a href="https://www.batexi.com/a/qde4v3z9.html">HDU 4442 Physical Examination&lpar;关于贪心排序&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
